<p align="center">
  <h1 align="center">✨ React Text Animate ✨</h1>
</p>

<p align="center">
  <em>
    Elevate your React/Next.js projects with a stunning collection of sleek, modern, and silky-smooth text animation components powered by Framer Motion. Effortlessly add a touch of elegance and bring your UI to life, adding dynamic flair and visual appeal that will leave your users impressed!
  </em>
</p>

<p align="center">
  <!-- NPM package version -->
  <a href="https://www.npmjs.com/package/react-text-animate" target="_blank" rel="noopener noreferrer">
	  <img src="https://img.shields.io/npm/v/react-text-animate?logo=npm&color=cb3837&style=for-the-badge" alt="license">
  </a>

  <!-- Minified Bundle Size -->
  <img src="https://img.shields.io/npm/unpacked-size/react-text-animate/latest?style=for-the-badge&color=yellow" alt="Minzipped Size">

  <!-- Latest GitHub Release-->
  <a href="https://github.com/mwaqar29/react-text-animate/releases" target="_blank" rel="noopener noreferrer">
    <img alt="GitHub Release" src="https://img.shields.io/github/v/release/mwaqar29/react-text-animate?style=for-the-badge&logo=github&label=Release&color=plum">
  </a>

  <!-- Last Commit -->
  <img src="https://img.shields.io/github/last-commit/mwaqar29/react-text-animate?logo=git&logoColor=white&style=for-the-badge" alt="last-commit">

  <!-- Repo Top Language-->
  <img src="https://img.shields.io/github/languages/top/mwaqar29/react-text-animate?style=for-the-badge" alt="repo-top-language">

  <!-- License-->
  <a href="#-license" target="_blank" rel="noopener noreferrer">
  <img src="https://img.shields.io/github/license/mwaqar29/react-text-animate?logo=opensourceinitiative&logoColor=white&style=for-the-badge" alt="license">
  </a>

  <!-- Code of Conduct-->
  <a href="https://github.com/mwaqar29/react-text-animate/blob/main/CODE_OF_CONDUCT.md" target="_blank" rel="noopener noreferrer">
    <img src="https://img.shields.io/badge/code_of-conduct-hotpink?style=for-the-badge" alt="code-of-conduct">
  </a>

  <!-- Contributions Welcome-->
  <a href="#-contributing" target="_blank" rel="noopener noreferrer">
    <img src="https://img.shields.io/badge/contributions-welcome-8A2BE2?style=for-the-badge" alt="contributions-welcome">
  </a>

  <!-- Commitzen Friendly-->
  <a href="http://commitizen.github.io/cz-cli/" target="_blank" rel="noopener noreferrer">
    <img src="https://img.shields.io/badge/commitizen-friendly-brightgreen.svg?style=for-the-badge" alt="Commitizen friendly" />
  </a>
<p>

<p align="center">
  <em>Built with 🛠️</em>
</p>

<p align="center">
  <img src="https://cdn.jsdelivr.net/gh/devicons/devicon@latest/icons/react/react-original.svg" height="42" width="42" />
  <img src="https://cdn.jsdelivr.net/gh/devicons/devicon@latest/icons/typescript/typescript-original.svg" height="42" width="42" />
  <img src="https://cdn.jsdelivr.net/gh/devicons/devicon@latest/icons/rollup/rollup-original.svg" height="42" width="42" />
  <img src="https://cdn.jsdelivr.net/gh/devicons/devicon@latest/icons/framermotion/framermotion-original.svg" height="42" width="42" />
  <img src="https://cdn.jsdelivr.net/gh/devicons/devicon@latest/icons/eslint/eslint-original.svg" height="42" width="42" />
  <img src="https://cdn.jsdelivr.net/gh/devicons/devicon@latest/icons/html5/html5-original.svg" height="42" width="42" />
  <img src="https://cdn.jsdelivr.net/gh/devicons/devicon@latest/icons/css3/css3-original.svg" height="42" width="42" />
</p>

<br/>

<!-- Codesandbox Link -->
<p align="center">
  <a href="https://4mrhxr.csb.app/" target="_blank" rel="noopener noreferrer">
    <img src="https://img.shields.io/badge/codesandbox-live-d6fb41?style=for-the-badge&labelColor=black&logo=codesandbox" alt="Codesandbox Live Demo Link" />
  </a>
</p>

<hr/>

## 🗂️ Table of Contents

- [📍 Overview](#-overview)
- [🎁 Features](#-features)
- [📂 Repository Structure](#-repository-structure)
- [🚀 Quick Start](#-quick-start)
  - [⚙️ Installation](#️-installation)
  - [💻 Usage](#-usage)
- [🧭 Project Roadmap](#-project-roadmap)
- [🤝 Contributing](#-contributing)
- [📒 Changelog](#-changelog)
- [📄 License](#-license)
- [👊 Acknowledgments](#-acknowledgments)

## 📍 Overview

The `react-text-animate` library offers a seamless blend of ease & functionality, providing declarative, plug-and-play animated text components alongside a range of customization options. Built entirely with TypeScript and powered by Framer Motion, the library delivers production-ready animations with buttery-smooth performance at 60fps. The animated text components also feature built-in viewport detection that activates animations as the component scrolls into view, while also offering customization options to enhance their versatility. With robust code quality maintained by ESLint and Prettier, and an optimized, compact bundle size achieved through Rollup's tree shaking and dead code elimination, this library is both efficient and reliable.

## 🎁 Features

- 🧩 **Simple and Declarative**: Plug-and-play components that are easy to use yet customizable.
- 🔭 **Built-in Viewport Detection**: Activates animations as the component scrolls into view.
- 📘 **TypeScript-Powered:** Components are built purely with TypeScript for type safety and reliability.
- 🌀 **Fueled by Framer Motion**: Production-ready, 60fps animations that are smooth and performant.
- ✅ **High-Quality Code**: ESLint and Prettier integration ensures clean, robust code.
- ♿️ **Screen Reader Accessible**: The text within the components is fully readable by screen readers.
- ⚡ **Optimized Bundle Size**: Rollup's tree shaking and dead code elimination keep the bundle lightweight and efficient.

## 📂 Repository Structure

```sh
└── react-text-animate/
    ├── .husky/
    ├── src/
    │   ├── assets/
    │   ├── components/
    │   │   ├── text-effect-3/
    │   │   │   ├── index.tsx
    │   │   │   └── index.css
    │   │   └── ...
    │   ├── index.ts
    │   └── styles.css
    ├── package.json
    ├── rollup.config.ts
    └── ...
```

## 🚀 Quick Start

**Requirements:**

A React/Next.js application.

> [!NOTE]
> This package requires your project to use **React v18.0** or higher to function properly.

### ⚙️ Installation

Install the `react-text-animate` library in your React/Next.js application using one of the the below commands (as per the package manager installed in your system).

- npm
  ```sh
  npm i react-text-animate
  ```
- yarn
  ```sh
  yarn add react-text-animate
  ```
- pnpm
  ```sh
  pnpm add react-text-animate
  ```

### 💻 Usage

**Note**: Check out the live demo of this package along with many more usage examples on [CodeSandbox](https://codesandbox.io/p/sandbox/react-text-animate-demo-4mrhxr).

Out of the box, you can use one of the components as shown in the example below:

```jsx
import { TextEffectOne } from 'react-text-animate'

const App = () => {
  return <TextEffectOne text="TYPOGRAPHY" />
}

export default App
```

And here is the result! 🎉

![Text Effect One Result](https://github.com/mwaqar29/react-text-animate/blob/main/src/assets/images/example/text-effect-1-result.gif)

Yes, getting started is that simple! However, don't let the simplicity make you think there's nothing more to it. Each component offers a range of customization options. Feel free to experiment with these settings until you achieve your desired result. Get creative by adjusting colors, letter spacing, font style and font weight, and try different font families using the `className` and `style` props! Below are the props available for the `<TextEffectOne />` component that was used above:

> [!NOTE]
> The only **required** prop is `text`. Rest all are optional.
> Most of the props for the `<TextEffectOne />` component are common to all other animated text components. Only the **additional** props for other components will be listed to avoid redundancy. So a component (except `<TextEffectOne />`) may have more props than those listed in the table below.

#### Component: `<TextEffectOne />`

| Prop                      | Type                        | Default                                                | Description                                                                                                                                                                                |
| ------------------------- | --------------------------- | ------------------------------------------------------ | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------ |
| `wrapperElement`          | keyof JSX.IntrinsicElements | `p`                                                    | JSX-equivalent of HTML Element wrapping the entire component<br/>For e.g. `div`, `span`, `strong`, etc.                                                                                    |
| `text`                    | string \| string[]          | `undefined`                                            | The actual text to animate. For e.g. `"ELEGANT"`, `["Multline", "Line 2"]`, etc.                                                                                                           |
| `className`               | string                      | `undefined`                                            | HTML class name applied to the wrapper element to style the text. **Tip**: Use `tailwind` utility classes for styling!                                                                     |
| `style`                   | CSSProperties               | `undefined`                                            | JSX inline style object. For e.g. `{ fontStyle: 'italic' }`.                                                                                                                               |
| `rotation`                | number                      | `0`                                                    | Rotation Angle of letters (or words, when `wordByWord` prop is `true`). For e.g. `67.5`, `-45`, etc (in degrees).                                                                          |
| `staggerDuration`         | number                      | `0.1`                                                  | Delay between the animation of each individual letter (in seconds).                                                                                                                        |
| `fromTop`                 | boolean                     | `false`                                                | Animate letters from top to bottom.                                                                                                                                                        |
| `fromLast`                | boolean                     | `false`                                                | Animate letters from right to left.                                                                                                                                                        |
| `wordByWord`              | boolean                     | `false`                                                | Animate letters word-by-word instead of character-by-character.                                                                                                                            |
| `initialDelay`            | number                      | `0`                                                    | Delay before starting the animation (in seconds).                                                                                                                                          |
| `animateOnce`             | boolean                     | `false`                                                | When the text component scrolls out of view and then back into view, the animation is triggered again. This prop can be used to turn this behaviour off.                                   |
| `elementVisibilityAmount` | number                      | `0.5`                                                  | The amount of an element that needs to enter the viewport for the animation to be triggered. This is defined as a number between 0 and 1.                                                  |
| `lineHeight`              | number                      | `0.8` for text with only uppercase letters, else `1.2` | Specifies the line height to prevent lowercase characters with descenders (like 'g', 'j', 'p', 'q', 'y') from being cut off in some fonts. Adjust this property to fit the font as needed. |

#### Component: `<TextEffectTwo />`

| Prop                | Type    | Default     | Description                                                   |
| ------------------- | ------- | ----------- | ------------------------------------------------------------- |
| `text`              | string  | `undefined` | The actual text to animate. For e.g. `"Hey yo!"`.             |
| `filter`            | boolean | `true`      | Toggles the blur effect in the animation.                     |
| `animationDuration` | number  | `0.1`       | TIme taken for the entire animation to complete (in seconds). |

#### Component: `<TextEffectThree />`

The props for this component and further components mentioned below include some from both `<TextEffectOne />` and `<TextEffectTwo />`.<br/>
_**Note**: This component animates on **hover**! And works best with text that contains only **uppercase** characters._

#### Component: `<TextEffectFour />`

| Prop              | Type         | Default     | Description                                                                                                                                                                                                                      |
| ----------------- | ------------ | ----------- | -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| `cursorConfig`    | CursorConfig | `undefined` | The CSS styling of the cursor. Use it to create different types of cursors & override the defaults. **Note**: Initially, this prop is `undefined`, but default styling is applied to ensure the cursor is visible on the screen. |
| `cursorBlinkRate` | number       | `0.35`      | Sets the cursor blink speed/interval (in seconds). Lower values increase blink frequency; higher values decrease it.                                                                                                             |
| `fromCenter`      | boolean      | `false`     | Start the animation from the center.                                                                                                                                                                                             |

## 🧭 Project Roadmap

We'll keep adding more animated text components in future! Keep checking back every weekend for updates on new components and enhancements.
Additionally, if you want to contribute any, do check out the [Contributing](#-contributing) section.

## 📒 Changelog

### 🔥 What's new!

### [2.1.0](https://github.com/mwaqar29/react-text-animate/compare/2.0.2...2.1.0) (2024-08-31)

#### Features

- **components:** added grapheme spliter which adds emoji & foreign lang support ([b1e0a39](https://github.com/mwaqar29/react-text-animate/commit/b1e0a392904bab12b3d8a2118ef801899e9b9e13))
- **text-effect-1:** added new prop 'wordByWord' ([4b06a71](https://github.com/mwaqar29/react-text-animate/commit/4b06a7164e6739acd660d44be58de382fa408585))
- **text-effect-4:** added new component text-effect-4! ([e203fb1](https://github.com/mwaqar29/react-text-animate/commit/e203fb16ef8c1a50fbcdfe81068efa85ef74124a))

### [2.0.2](https://github.com/mwaqar29/react-text-animate/compare/2.0.1...2.0.2) (2024-08-27)

#### Bug Fixes

- **te1&3:** fixed lineHeight issue caused by 'nbsp' ([236e7fb](https://github.com/mwaqar29/react-text-animate/commit/236e7fb5d9e558d7f1e7ea38850efe18113f4f8e))

> [!NOTE]
> Please read [CHANGELOG.md](https://github.com/mwaqar29/react-text-animate/blob/main/CHANGELOG.md) for complete list of changes.

## 🤝 Contributing

> [!IMPORTANT]
> Please read [CONTRIBUTING.md](https://github.com/mwaqar29/react-text-animate/blob/main/CONTRIBUTING.md) & [CODE_OF_CONDUCT.md](https://github.com/mwaqar29/react-text-animate/blob/main/CODE_OF_CONDUCT.md) for details on our code of conduct, and the process for submitting pull requests to us.
> I also strongly recommend that you check if you are using the latest version of the project. If you are not up-to-date, see if updating fixes your issue first. Also, check for open issues and pull requests to see if someone else is working on something similar.

Contributions are welcome! Here are several ways you can contribute:

- **[Report Issues](https://github.com/mwaqar29/react-text-animate/issues)**: Submit bugs found or log feature requests for the `react-text-animate` project.
- **[Submit Pull Requests](https://github.com/mwaqar29/react-text-animate/blob/main/CONTRIBUTING.md)**: Review open PRs and contribute by submitting your own new animated text component PRs.

<br/>
<h6 align="center">Thanks 👊 to all contributors!</h6>
<p align="center">
   <a href="https://github.com/mwaqar29/react-text-animate/graphs/contributors">
      <img src="https://contrib.rocks/image?repo=mwaqar29/react-text-animate">
   </a>
</p>

## 📄 License

This project is protected under the [MIT](https://choosealicense.com/licenses/mit/) License. For more details, refer to the [LICENSE](https://github.com/mwaqar29/react-text-animate/blob/main/LICENSE) file.

## 👊 Acknowledgments

Some of these animations are inspired by the work of brilliant and generous individuals. I want to extend my heartfelt thanks to them for their invaluable contributions to the community.

- [Tom Is Loading, Hover Dev LLC](https://github.com/TomIsLoading)
- [Manu Arora, Aceternity UI](https://github.com/manuarora700)

[**Return to 'Overview' ⬆️**](#-overview)

<p align="center">
  Thanks for reading!<br/>
  <em>Love this project ? Don't forget to</em> ⭐ <em>me!</em>
</p>

<p align="center">
  <img src="https://img.shields.io/badge/MADE_WITH-%E2%9D%A4-D0021B?style=for-the-badge&labelColor=D22238" alt="Made with ❤">
</p>
